diff --git a/tests/manager/test_all.py b/tests/manager/test_all.py
index bb756887..3d29c922 100644
--- a/tests/manager/test_all.py
+++ b/tests/manager/test_all.py
@@ -127,6 +127,12 @@ def test_events_agenda_redirect(app, admin_user):
         resp = app.get('/manage/agendas/%s/' % agenda_id, status=302)
     assert resp.location.endswith('/manage/agendas/%s/day/' % agenda.pk)
 
+    agenda.default_view = 'week'
+    agenda.save()
+    for agenda_id in [agenda.pk, agenda.slug]:
+        resp = app.get('/manage/agendas/%s/' % agenda_id, status=302)
+    assert resp.location.endswith('/manage/agendas/%s/week/' % agenda.pk)
+
 
 @freezegun.freeze_time('2020-07-12')
 def test_events_agenda_month_redirect(app, admin_user):
@@ -180,6 +186,58 @@ def test_events_agenda_month_redirect(app, admin_user):
     assert resp.location.endswith('/manage/agendas/%s/2020/7/' % agenda.pk)
 
 
+@freezegun.freeze_time('2020-07-12')
+def test_events_agenda_week_redirect(app, admin_user):
+    agenda = Agenda.objects.create(label='Foo Bar', kind='events')
+
+    app = login(app)
+    # no event, redirect to current week
+    resp = app.get('/manage/agendas/%s/week/' % agenda.pk, status=302)
+    assert resp.location.endswith('/manage/agendas/%s/2020/week/27/' % agenda.pk)
+
+    # only past events, redirect to last event month
+    Event.objects.create(
+        agenda=agenda,
+        places=1,
+        start_datetime=now() - datetime.timedelta(days=60),
+    )
+    resp = app.get('/manage/agendas/%s/week/' % agenda.pk, status=302)
+    assert resp.location.endswith('/manage/agendas/%s/2020/week/19/' % agenda.pk)
+    Event.objects.create(
+        agenda=agenda,
+        places=1,
+        start_datetime=now() - datetime.timedelta(days=30),
+    )
+    resp = app.get('/manage/agendas/%s/week/' % agenda.pk, status=302)
+    assert resp.location.endswith('/manage/agendas/%s/2020/week/23/' % agenda.pk)
+
+    # future events
+    Event.objects.create(
+        agenda=agenda,
+        places=1,
+        start_datetime=now() + datetime.timedelta(days=60),
+    )
+    resp = app.get('/manage/agendas/%s/week/' % agenda.pk, status=302)
+    assert resp.location.endswith('/manage/agendas/%s/2020/week/36/' % agenda.pk)
+    Event.objects.create(
+        agenda=agenda,
+        places=1,
+        start_datetime=now() + datetime.timedelta(days=30),
+    )
+    resp = app.get('/manage/agendas/%s/week/' % agenda.pk, status=302)
+    assert resp.location.endswith('/manage/agendas/%s/2020/week/32/' % agenda.pk)
+
+    # don't check events for meetings
+    agenda.kind = 'virtual'
+    agenda.save()
+    resp = app.get('/manage/agendas/%s/week/' % agenda.pk, status=302)
+    assert resp.location.endswith('/manage/agendas/%s/2020/week/27/' % agenda.pk)
+    agenda.kind = 'meetings'
+    agenda.save()
+    resp = app.get('/manage/agendas/%s/week/' % agenda.pk, status=302)
+    assert resp.location.endswith('/manage/agendas/%s/2020/week/27/' % agenda.pk)
+
+
 @freezegun.freeze_time('2020-07-12')
 def test_events_agenda_day_redirect(app, admin_user):
     agenda = Agenda.objects.create(label='Foo Bar', kind='events')
@@ -246,6 +304,12 @@ def test_meetings_agenda_redirect(app, admin_user):
         resp = app.get('/manage/agendas/%s/' % agenda_id, status=302)
     assert resp.location.endswith('/manage/agendas/%s/month/' % agenda.pk)
 
+    agenda.default_view = 'week'
+    agenda.save()
+    for agenda_id in [agenda.pk, agenda.slug]:
+        resp = app.get('/manage/agendas/%s/' % agenda_id, status=302)
+    assert resp.location.endswith('/manage/agendas/%s/week/' % agenda.pk)
+
 
 def test_virtual_agenda_redirect(app, admin_user):
     agenda = Agenda.objects.create(label='Foo Bar', kind='virtual')
@@ -261,6 +325,12 @@ def test_virtual_agenda_redirect(app, admin_user):
         resp = app.get('/manage/agendas/%s/' % agenda_id, status=302)
     assert resp.location.endswith('/manage/agendas/%s/month/' % agenda.pk)
 
+    agenda.default_view = 'week'
+    agenda.save()
+    for agenda_id in [agenda.pk, agenda.slug]:
+        resp = app.get('/manage/agendas/%s/' % agenda_id, status=302)
+    assert resp.location.endswith('/manage/agendas/%s/week/' % agenda.pk)
+
 
 def test_view_agendas_as_admin(app, admin_user):
     Agenda.objects.create(label='Bar Foo')
@@ -929,10 +999,11 @@ def test_agenda_day_view(app, admin_user, manager_user, api_user, get_proper_htm
     'view',
     (
         '/manage/agendas/%(agenda)s/%(year)d/%(month)d/%(day)d/',
+        '/manage/agendas/%(agenda)s/%(year)d/week/%(week)d/',
         '/manage/agendas/%(agenda)s/%(year)d/%(month)d/',
     ),
 )
-def test_agenda_day_month_view_backoffice_url_translation(
+def test_agenda_day_week_month_view_backoffice_url_translation(
     app, admin_user, manager_user, api_user, settings, view
 ):
     agenda = Agenda.objects.create(label='New Example', kind='meetings')
@@ -959,7 +1030,13 @@ def test_agenda_day_month_view_backoffice_url_translation(
     booking = Booking.objects.get(pk=booking_id)
     assert booking.backoffice_url == backoffice_url
     date = booking.event.start_datetime
-    url = view % {'agenda': agenda.id, 'year': date.year, 'month': date.month, 'day': date.day}
+    url = view % {
+        'agenda': agenda.id,
+        'year': date.year,
+        'month': date.month,
+        'week': int(date.strftime('%W')),
+        'day': date.day,
+    }
     resp = app.get(url)
     assert resp.text.count('div class="booking') == 1
     assert backoffice_url in resp.text
@@ -1139,6 +1216,97 @@ def test_agenda_events_day_view_midnight(app, admin_user):
     assert len(resp.pyquery.find('.event-info')) == 1
 
 
+@freezegun.freeze_time('2020-10-01')
+def test_agenda_events_week_view(app, admin_user):
+    agenda = Agenda.objects.create(label='Events', kind='events')
+    Desk.objects.create(agenda=agenda, slug='_exceptions_holder')
+    today = datetime.date.today()
+
+    login(app)
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.pk, today.year, today.strftime('%W')))
+    assert 'Day view' in resp.text
+    assert "This week doesn't have any event configured." in resp.text
+
+    # add event in a future month, a wednesday
+    Event.objects.create(
+        label='xyz', start_datetime=localtime().replace(day=11, month=11, year=2020), places=10, agenda=agenda
+    )
+    # current month still doesn't have events
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, today.year, today.strftime('%W')))
+    assert "This week doesn't have any event configured." in resp.text
+
+    # add recurring event on every Wednesday
+    start_datetime = localtime().replace(day=4, month=11, year=2020)
+    event = Event.objects.create(
+        label='abc',
+        start_datetime=start_datetime,
+        places=10,
+        agenda=agenda,
+        recurrence_days=[start_datetime.weekday()],
+        recurrence_end_date=start_datetime + datetime.timedelta(days=60),
+    )
+    event.create_all_recurrences()
+
+    with CaptureQueriesContext(connection) as ctx:
+        resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, 2020, 45))
+        assert len(ctx.captured_queries) == 7
+    assert len(resp.pyquery.find('.event-info')) == 2
+    assert 'abc' in resp.pyquery.find('.event-info')[0].text
+    assert 'xyz' in resp.pyquery.find('.event-info')[1].text
+
+    TimePeriodException.objects.create(
+        desk=agenda.desk_set.get(),
+        start_datetime=start_datetime + datetime.timedelta(days=6),
+        end_datetime=start_datetime + datetime.timedelta(days=8),
+    )
+    agenda.update_event_recurrences()
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, 2020, 45))
+    assert len(resp.pyquery.find('.event-info')) == 1
+    assert 'Exception: 11/10/2020' in resp.pyquery.find('li')[4].text_content()
+    assert 'xyz' in resp.pyquery.find('li')[5].text_content()
+
+    # create another event with recurrence, the same day/time
+    start_datetime = localtime().replace(day=4, month=11, year=2020)
+    event = Event.objects.create(
+        label='def',
+        start_datetime=start_datetime,
+        places=10,
+        agenda=agenda,
+        recurrence_days=[start_datetime.weekday()],
+        recurrence_end_date=start_datetime + datetime.timedelta(days=60),
+    )
+    event.create_all_recurrences()
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, 2020, 49))
+    assert len(resp.pyquery.find('.event-info')) == 2
+
+    time = localtime(event.start_datetime).strftime('%H%M')
+    resp = resp.click('Dec. 9, 2020, 1 a.m.', index=1)
+    resp = resp.click('Options')
+    resp.form['start_datetime_1'] = '13:12'
+    resp = resp.form.submit(status=302).follow()
+    agenda.update_event_recurrences()
+
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, 2020, 49))
+    assert len(resp.pyquery.find('.event-info')) == 2
+    assert '1:12 p.m.' in resp.text
+
+    Event.objects.get(slug='abc--2020-12-02-%s' % time).cancel()
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, 2020, 48))
+    assert 'Cancelled' in resp.text
+
+
+def test_agenda_events_week_view_midnight(app, admin_user):
+    agenda = Agenda.objects.create(label='Events', kind='events', default_view='day')
+    midnight = localtime(now().replace(day=1, month=11, year=2020)).replace(hour=0, minute=0)
+    Event.objects.create(label='xyz', start_datetime=midnight, places=10, agenda=agenda)
+
+    login(app)
+    resp = app.get('/manage/agendas/%s/week/' % agenda.pk)
+    assert resp.location.endswith('/2020/week/43/')
+    resp = resp.follow()
+    assert len(resp.pyquery.find('.event-info')) == 1
+
+
 @freezegun.freeze_time('2020-10-01')
 def test_agenda_events_month_view(app, admin_user):
     agenda = Agenda.objects.create(label='Events', kind='events')
@@ -1365,7 +1533,8 @@ def test_agenda_month_view(app, admin_user, manager_user, api_user, get_proper_h
     resp = resp.click('Month view')
     assert resp.request.url.endswith('%s/%s/' % (today.year, today.month))
 
-    assert 'Day view' in resp.text  # date view link should be present
+    assert 'Day view' in resp.text  # day view link should be present
+    assert 'Week view' in resp.text  # week view link should be present
     assert 'No opening hours this month.' in resp.text
 
     today = datetime.date(2018, 11, 10)  # fixed day
